	.org $4009			; 16393
;
;	-----------------------------------------------------------------------
;	SYSTEM VARIABLES
;	-----------------------------------------------------------------------
;
;ERR_NR	.equ $4000		; 16384
;FLAGS	.equ $4001		; 16385
;ERR_SP	.equ $4002		; 16386
;RAMTOP	.equ $4004		; 16388
;MODE	.equ $4006		; 16390
;PPC	.equ $4007		; 16391

	.db $00				; VERSN
	.dw $0003			; E_PPC
	.dw Display			; D_FILE
	.dw Display+1			; DF_CC
	.dw Variables			; VARS
	.dw $0000			; DEST
	.dw BasicEnd			; E_LINE
	.dw BasicEnd+4			; CH_ADD
	.dw $0000			; X_PTR
	.dw BasicEnd+5			; STKBOT
	.dw BasicEnd+5			; STKEND
	.db $00				; BREG
	.dw MEMBOT			; MEM
	.db $00				; UNUSED1
	.db $02				; DF_SZ
	.dw $0000			; S_TOP
LAST_K
	.dw $FFFF			; 
	.db $FF				; DEBOUN
MARGIN
	.db $37				; 
;	.dw Display			; NXTLIN  -  autostart
	.dw Line1			; NXTLIN  -  autostart

	.dw $0000			; OLDPPC
	.db $00				; FLAGX
	.dw $0000			; STRLEN
	.dw $0C8D			; T_ADDR
	.dw $0000			; SEED
FRAMES
	.dw $0000			; 
	.dw $0000			; COORDS
	.db $BC				; PR_CC
	.dw $1821			; S_POSN
	.db $40				; CDFLAG
;
;	-----------------------------------------------------------------------
PRBUFF
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$76
;
;	-----------------------------------------------------------------------
MEMBOT
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$84,$20,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
;
;	-----------------------------------------------------------------------

	.db $00,$00			; UNUSED2
;
;	=======================================================================
;	BASIC
;	-----------------------------------------------------------------------
Line0
	.db $00,$00			; Line 0
	.dw Line1-Line0Txt		; Line 0 length
Line0Txt
	.db $EA				; REM
;
;	-----------------------------------------------------------------------
;
	.db $76,$76			; hide code
;
; *****************************************************************************
;	MACHINE CODE
;	***********************************************************************
MC_START
MCSta	.equ (2*MC_START)& $7FFF	; upper word for numeric encoding

	ld de,Display		; 
	ld hl,33		; 
	add hl,de		; 
	ld b,24			; 
next_pos
	inc de			; 
	inc hl			; 
	ld a,(de)		; 
	cp $76			; N/L ?
	jr z,new_line		;

	bit 7,a			;
	jr z,skip1		;

	xor $8F			;  
skip1
	and $0C			; 
	rrca			; 
	rrca			; 
	ld c,a			; 

	ld a,(hl)		; 
	rlca			; 
	jr nc,skip2		;

	xor $1F			;  
skip2
	rlca			; 
	and $0C			; 
	or c			; 
	cp $08			; N/L ?
	jr c,skip3		;

	xor $8F			;  
skip3
	ld (de),a		; 
	jp next_pos		; 
new_line
	djnz next_pos		; 
;
;	-----------------------------------------------------------------------
;	clear plot-buffer 
;	-----------------------------------------------------------------------
;
	ld bc,$2000		;
clr_buff
	dec hl			;
	ld (hl),c		; 
	djnz clr_buff		; 
;
;	-----------------------------------------------------------------------
;	GENERATE RANDOMISH NUMBER INTO A REGISTER
;	-----------------------------------------------------------------------
;
	LD A,($4034)		; 
RNDSEED:
	LD C,$00		; 
	ADD A,C			; 
	LD C,A			; 
	RRCA			; multiply by 32
	RRCA			; 
	RRCA			; 

	XOR $1F			; 

	ADD A,C			; 
	SBC A,$FF		; carry

	LD (RNDSEED+1),A	; 
;
;	-----------------------------------------------------------------------
;	plot
;	-----------------------------------------------------------------------
;
	and $3F			; 
	rra			; 
	inc a			; 
	ld c,a			;

	sbc a,a			; 
	add a,2			;

	add hl,bc		;
	ld (hl),a		; 
;
;	-----------------------------------------------------------------------
;	key test
;	-----------------------------------------------------------------------
;
	ld a,(LAST_K)		;
	inc a			; 
	jp z,MC_START		; 

	jp $0F4B		; ret via DEBOUNCE
;
;	***********************************************************************
;	END OF MACHINE CODE
; *****************************************************************************
;
	.db $76				; N/L (end of Line 0)
Line1
	.db $00,$01			; Line 1
	.dw Display-Line1Txt		; Line 1 length
Line1Txt
	.db $F9,$D4,$1C			; RAND USR 0
	.db $7E,$8F			; Number, exponent
	.db MCSta/256			; high byte and
	.db MCSta&255			; low byte of 'MC_START'
	.db $00,$00			; end of numeric encoding
	.db $76				; N/L (end of Line 2)
;
;	=======================================================================
;	Display file
;	-----------------------------------------------------------------------
Display
	.db $76
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$76
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$76
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$76
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$76
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$76
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$76
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$76
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$76
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$76
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$76
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$76
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$76
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$76
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$76
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$76
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$76
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$76
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$76
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$76
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$76
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$76
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$76
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$76
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$76
;
;	-----------------------------------------------------------------------
plot_buf
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
;
;	=======================================================================
;	BASIC Variables
;	-----------------------------------------------------------------------
Variables
	.db $80
BasicEnd
;
;	=======================================================================
;
	.end

